#!/bin/bash
#set -x
echo ""
echo "#############################################################"
echo "#                                                           #"
echo "# Skript kontroluje napadeni Linux serveru operaci Windigo  #"
echo "#                                                           #"
echo "# (c) AA COMPUTER, s.r.o., Author: Ing. Leos Houser         #"
echo "# Posledni zmena: 7.4.2014                                  #"
echo "# Verze: 1.0.2                                              #"
echo "# Oproti verzi 1.0.1 pridana kontrola velikosti knihovny    #"
echo "#  libkeyutils, pridany nove signatury pro Linux/Cdorked    #"
echo "#  a dalsi drobna vylepseni.                                #"
echo "#                                                           #"
echo "#############################################################"
echo ""

# Pocatecni kontrola existence kontrolnich souctu v adresari.
if [ -r soucty-Perl-Calfbot.txt ]; then
  echo "Kontroluji soubor soucty-Perl-Calfbot.txt  ... OK" 
else 
  echo "Spustte kontrolu z adresare kontrola_operace_windigo-X.X.X."
  echo "Koncim."
  exit 1
fi
sleep 1

if [ -r soucty-Linux-Cdorked.txt ]; then
  echo "Kontroluji soubor soucty-Linux-Cdorked.txt ... OK"
else
  echo "Spustte kontrolu z adresare kontrola_operace_windigo-X.X.X."
  echo "Koncim."
  exit 1
fi
sleep 1

if [ -r soucty-Linux-Onimiki.txt ]; then
  echo "Kontroluji soubor soucty-Linux-Onimiki.txt ... OK"
else
  echo "Spustte kontrolu z adresare kontrola_operace_windigo-X.X.X."
  echo "Koncim."
  exit 1
fi
sleep 1

if [ -r soucty-Linux-Ebury.txt ]; then
  echo "Kontroluji soubor soucty-Linux-Ebury.txt   ... OK"
else
  echo "Spustte kontrolu z adresare kontrola_operace_windigo-X.X.X."
  echo "Koncim."
  exit 1
fi
sleep 1


# Vlastni kontroly napadeni ...

echo ""
echo "RYCHLE IDENTIFIKATORY NAPADENI:"
echo ""
echo "Kontrola identifikacnich retezcu napadeni Linux/Ebury" 
echo " v souborech ..."
echo "Oznacuji verzi napadeni. Podezrele jsou zejmena retezce mezi"
echo " 0.4.4 a 0.8.0"

echo ""
echo -n "/usr/sbin/sshd: "
strings /usr/sbin/sshd |grep "0\.[0-8]\.[0-9]" |grep -v 127\.0\.0\.1 |grep -v 0\.0\.0\.0 || echo OK
echo -n "/usr/bin/ssh-add: "
strings /usr/bin/ssh-add |grep "0\.[0-8]\.[0-9]" |grep -v 127\.0\.0\.1 |grep -v 0\.0\.0\.0 || echo OK
echo -n "/usr/bin/ssh: "
strings /usr/bin/ssh |grep "0\.[0-8]\.[0-9]" |grep -v 127\.0\.0\.1 |grep -v 0\.0\.0\.0 || echo OK

echo "________________________________________________"
echo ""

echo "Rychla kontrola ssh ..."
ssh -G 2>&1 | grep -e illegal -e unknown > /dev/null && echo "System OK" || echo "SYSTEM INFIKOVAN !!!"

echo "________________________________________________"
echo ""

sleep 2

echo "Inspekce sdilene pameti ..."
echo ""
SSHD_PID=`ps axf |grep /usr/sbin/sshd |grep -v grep |awk '{print $1}'`

echo "SSHD PID je: $SSHD_PID"

IPCS_SHMID=`ipcs -m -p |grep $SSHD_PID |awk '{print $1}'`

echo "Velice podezrele jsou procesy daemona SSHD, ktere vyuzivaji" 
echo " sdilenou pamet:"
echo "Vypisuji je ...."
ipcs -m -p |head -3
ipcs -m -p |grep $SSHD_PID
echo ""

if [ "`ipcs -m -p |grep $SSHD_PID`" = "" ]; then
  echo "Podezrele procesy nenalezeny, system OK."
else
  echo "Kontrola sdilene pameti hlasi napadeni systemu!!!"
  echo "Velice podezrele sdileni pameti, zejmena pri pravech 666!!!" 
  ipcs -m |head -3
  IPCS_M_P=`ipcs -m -p |grep $SSHD_PID |awk '{print $1}'`
  IPCS_M=`ipcs -m |grep $IPCS_M_P`
  echo $IPCS_M
  echo ""
fi


echo "________________________________________________"
echo ""

echo "Nalezeni napadeni Perl/Calfbot ze souboru v adresari /tmp ....."
flock --nb "/tmp/..." echo "System OK" || echo "SYSTEM NAPADEN !!!"

echo ""
echo "Pomoci prikazu: "
echo "# lsof "/tmp/..." zjistite, jaky proces vlastni prislusny zamek."
echo "________________________________________________"
echo ""

echo "Kontrola daemona SSHD na napadeni Linux/Ebury pomoci"
echo " kontrolnich souctu ..."
echo ""
echo "Kontroluji daemona SSHD ..."
SHA1_SSHDDD=`sha1sum /usr/sbin/sshd |awk '{print $1}'`
echo -n "SHA1SUM daemona SSHD je: "
echo $SHA1_SSHDDD

echo ""
echo "Porovnavam s nebezpecnymi kontrolnimi soucty ..."

for i in `cat soucty-Linux-Ebury.txt |grep sshd`
do
  if [ "$i" = "$SHA1_SSHDDD" ];then
    echo "SYSTEM NAPADEN !!!"
    exit 2
  else
    echo "OK"
  fi
done

echo "________________________________________________"
echo ""

sleep 2

echo "Kontroluji secure shell SSH ..."
SHA1_SSHDDD=`sha1sum /usr/bin/ssh |awk '{print $1}'`
echo -n "SHA1SUM SSH je: "
echo $SHA1_SSHDDD

echo ""
echo "Porovnavam s nebezpecnymi kontrolnimi soucty ..."

for i in `cat soucty-Linux-Ebury.txt |grep ssh |grep -v sshd |awk '{print $1}'`
do
  if [ "$i" = "$SHA1_SSHDDD" ];then
    echo "SYSTEM NAPADEN !!!"
    exit 2
  else
    echo "OK"
  fi
done

echo "________________________________________________"
echo ""

sleep 2

echo "Kontroluji SSD-ADD ..."
SHA1_SSHDDD=`sha1sum /usr/bin/ssh-add | awk '{print $1}'`
echo -n "SHA1SUM SSH-ADD je: "
echo $SHA1_SSHDDD

echo ""
echo "Porovnavam s nebezpecnymi kontrolnimi soucty ..."
for i in `cat soucty-Linux-Ebury.txt |grep ssh-add |awk '{print $1}'`
do
  if [ "$i" = "$SHA1_SSHDDD" ];then
    echo "SYSTEM NAPADEN !!!"
    exit 2
  else
    echo "OK"
  fi
done

echo "________________________________________________"
echo ""

sleep 2

echo "Kontroluji libkeyutils.so ..."

echo ""
for j in `locate libkeyutils`
do
  if [ "`file $j |grep ELF`" != "" ]; then 
#    echo -n "$j: "
#    file $j |awk -F ":" '{print $1}'
    file $j |awk -F ":" '{print $1}' >> LIBKEYUTILS.SO.$$
  fi
done

for LIBKEYUTIL_FILE in `cat LIBKEYUTILS.SO.$$`
do
  echo "Kontroluji velikost $LIBKEYUTIL_FILE ..."
  SHA1_SSHDDD=`sha1sum $LIBKEYUTIL_FILE |awk '{print $1}'`
  VELIKOST_LIBKEYUTIL_FILE=`ls -l $LIBKEYUTIL_FILE |awk '{print $5}'`
  echo "" 
  echo -n "Jeho velikost je $VELIKOST_LIBKEYUTIL_FILE bytu. "
  
  if [ $VELIKOST_LIBKEYUTIL_FILE -ge 18000 ]; then
    echo "POZOR!! Soubor je podezrele veliky!!"
  else
    echo "To vypada OK ..."
  fi 
 
  sleep 2
  
  echo ""
  echo "SHA1SUM souboru $LIBKEYUTIL_FILE je: "
  echo $SHA1_SSHDDD
  echo "Porovnavam soubor $LIBKEYUTIL_FILE s nebezpecnymi "
  echo " kontrolnimi soucty ..."

  for i in `cat soucty-Linux-Ebury.txt |grep libkeyutils |awk '{print $1}'`
  do
    if [ "$i" = "$SHA1_SSHDDD" ];then
      echo "SYSTEM NAPADEN !!!"
      exit 2
    else
      echo "OK"
    fi
  done
  echo ""
done

rm -f LIBKEYUTILS.SO.$$

echo "________________________________________________"
echo ""

sleep 2

if [ -x /usr/sbin/apache2 ]; then
  echo "Testuji /usr/sbin/apache2 na napadeni Linux/Cdorked pomoci"
  echo " kontrolnich souctu ..."
  SHA1_APACHE="`sha1sum /usr/sbin/apache2 |awk '{print $1}'`"
  echo -n "SHA1SUM daemona APACHE2 je: "
  echo $SHA1_APACHE

  echo ""
  echo "Porovnavam s nebezpecnymi kontrolnimi soucty ..."
  for i in `cat soucty-Linux-Cdorked.txt`
  do
    if [ "$i" = "$SHA1_APACHE" ]; then
      echo "System napaden !!!"
      echo "Kontrolni soucet apache2 je $SHA1_APACHE, nalezena shoda!!!"
    else 
      echo "OK"
    fi
  done 

echo "________________________________________________"
echo ""

fi

if [ -x /usr/sbin/httpd ]; then
  echo "Testuji /usr/sbin/httpd na napadeni Linux/Cdorked pomoci "
  echo " kontrolnich souctu ..."
  SHA1_APACHE="`sha1sum /usr/sbin/httpd |awk '{print $1}'`"
  echo "SHA1SUM daemona HTTPD je: "
  echo $SHA1_APACHE

  echo ""
  echo "Porovnavam s nebezpecnymi kontrolnimi soucty ..."

  for i in `cat soucty-Linux-Cdorked.txt`
  do
    if [ "$i" = "$SHA1_APACHE" ]; then
      echo "System napaden !!!"
      echo "Kontrolni soucet httpd je $SHA1_APACHE, nalezena shoda!!!"
    else
      echo "OK"
    fi
  done


echo "________________________________________________"
echo ""

fi

sleep 2

if [ -x /usr/sbin/named ]; then
  echo "Testuji NAMED na napadeni Linux/Onimiki pomoci "
  echo " kontrolnich souctu ..."
  SHA1_NAMED=`sha1sum /usr/sbin/named |awk '{print $1}'`
  echo -n "SHA1SUM daemona NAMED je: " 
  echo $SHA1_NAMED
  echo ""

  echo "Porovnavam s nebezpecnymi kontrolnimi soucty ..."
  for i in `cat soucty-Linux-Onimiki.txt`
  do
    if [ "$i" = "$SHA1_NAMED" ]; then
      echo "System napaden !!!"
      echo "Kontrolni soucet daemona NAMED je $SHA1_NAMED, nalezena shoda!!!"
    else
      echo "OK"
    fi
  done


echo "________________________________________________"
echo ""

fi

if [ -x /usr/bin/perl ]; then
  echo "Testuji Perl na napadeni Perl/Calfbot pomoci kontrolnich "
  echo " souctu ..."
  echo -n "SHA1SUM Perlu je: "
  SHA1_PERL="`sha1sum /usr/bin/perl  |awk '{print $1}'`"
  echo "$SHA1_PERL"
  echo ""

  echo "Porovnavam s nebezpecnymi kontrolnimi soucty ..."
  for i in `cat soucty-Perl-Calfbot.txt`
  do
    if [ "$i" = "$SHA1_PERL" ]; then
      echo "System napaden !!!"
      echo "Kontrolni soucet Perlu je $SHA1_PERL, nalezena shoda!!!"
    else
      echo "OK"
    fi
  done

echo "________________________________________________"
echo ""

fi

echo "Tipy pro jednoduche kontroly, co nelze automatizovet:"
echo ""
echo "Diagnostika napadeni Linux/Cdorked ..."
echo "Prikaz:"
echo "\$ curl -i http://vas_server/favicon.iso | grep "Location:""
echo ""
echo "ktery vypise hlasku:"
echo "Location: http://google.com/"
echo ""
echo "znamena napadeny webovy server ...."
echo "________________________________________________"
echo ""

echo "Diagnostika napadeni Linux/Ebury pomoci tcpdumpu"
echo ""
echo "Prikaz:"
echo "\$ tcpdump -p"
echo "referuje o pristupech na podivne domeny, jako napr. "
echo " o5o8c1berdn.net, k2l8z1yeodm.info, aj."
echo ""

exit 0
